// WD-Timer mit Sleep
#include <avr/io.h>
#include <avr/interrupt.h> 
#include <avr/sleep.h>
#include <avr/wdt.h>
#include <util/delay.h>

#define WD_PRESCALE 7  //  8:=> 4s


ISR(WATCHDOG_vect)
{
	//PORTB ^= (1<<PB0) | (1<<PB1);  // Toogle both outputs

  PORTB |= (1 << PB0);
  _delay_ms(1);
  PORTB &= ~(1 << PB0);

}


int main()
{
	uint8_t wdt_flags, wd_timer_prescale;

  DDRA    = 0b00000000;
  DDRB    = 0b00000011;

  PORTA   = 0b00000000;       
  PORTB   = 0b00000000;

	// Strom sparen
	PRR |= (1 << PRUSI) | (1 << PRTIM1) | (1 << PRTIM0) | (1 << PRADC);   // USI, Timer1/0, ADC ungenutzt: abschalten 


	// Power-Down Sleep Mode einstellen
	set_sleep_mode(SLEEP_MODE_PWR_DOWN);	// stromsparend, aufwecken ber WD oder INT0
	sleep_enable(); 						          // Schlafmodus vorbereiten

	// Watchdog IRQ vorbereiten
	wd_timer_prescale = WD_PRESCALE;
	if (wd_timer_prescale > 9 ) wd_timer_prescale=9;
	wdt_flags=wd_timer_prescale & 7;
	if (wd_timer_prescale > 7) wdt_flags|= (1<<5);  // wdt_flags enthlt den Prescalerwert (0 .. 9)

	WDTCSR |= (1<<WDCE) | (1<<WDE);  	// Watchdog aktivieren
	WDTCSR = wdt_flags | (1<<WDIE);	  // set watchdog timeout value, start WD-IRQ
	sei();

	while (1)
	{
		sleep_mode();   // WD-IRQ weckt, toggelt Ports und schlft weiter. Stromaufnahme: <10A ohne Last
	}

}
